' Attiny-13-Mutteruhr
' Dient zur Anstuerung von Tochteruhren mit Minutenschaltung
'
' Ein mal pro Minute wird ein Impuls von 400 ms Dauer erzeugt. Die Polaritaet muss
' bei jedem Impuls gewechselt werden (Brckenschaltung mit MAX232)
' Durch einen Taster kann in einen Testmodus umgeschaltet werden; die Minutenimpulse
' kommen dann alle 2 sec.
'
'
' Pinbelegung:
'
' PB0: Minuten- Ausgang
' PB1: Taster fuer Testmodus
' PB2: Eingang 32 kHz- Oszillator
' PB3 + PB4: Betriebsspannung Max232
'
' 32768 / 356 = 128
' -> 128 Interrupts / sec
' benoetigt wird Minutentakt
' -> 128 * 60 = 7680
' da Oszillator etwas zu langsam (20 sec / Tag): berlauf bei 7678 statt 7680
'
'----------------------------------------------------------


$regfile = "Attiny13.dat"
$crystal = 600000                                           ' gefust auf 4,8 MHz / 8

$hwstack = 36
$swstack = 4
$framesize = 4


' Variablen fuer Zeitberechnung

Dim S As Word                                               ' Zaehler 1/128 Sekunden
Dim T As Bit                                                ' T togglebit
Dim C As Word                                               ' Vergleichswert fr Zaehler



Portb = &B00000010                                          ' Pullup fr Eingang PB1
Ddrb = &B00011001                                           ' PB0 Takt fuer Max232, PB3 und 4 schalten Versorgung Max232

' Stromspar- Funktionen nutzen

Acsr.acd = 0                                                ' Analog-Komparator ausschalten


' Timer zu Fuss konfigurieren:

Tccr0a = 0                                                  ' Betrieb als Zaehler bis 255; einfach nur berlauf
Tccr0b = &B00000110                                         ' externer Takt an TO; falling edge
Timsk0 = &B00000010                                         ' Interruptquelle:  Counter0 overflow

Sreg.7 = 1                                                  ' Interrupts global freigeben

On Timer0 Ontimer0                                          ' Interrupt-Routine fr Timer0-Overflow

'----------------------------------------------------------




 Portb.3 = 1                                                ' Betriebsspannung fr MAX232 einschalten
 Portb.4 = 1

 Wait 2                                                     ' abwarten, damit die Ladungspumpe die Kondensatoren laedt

 Portb.3 = 0                                                ' Betriebsspannung fr MAX232 ausschalten
 Portb.4 = 0


Do                                                          ' Hauptschleife

   If Pinb.1 = 0 Then
      C = 254                                               ' statt Minuten- Modus 2sec- Modus (Test)
   Else
      C = 7677                                              ' 1 Min- Modus incl. Korrekturfaktor, da Oszillator zu langsam
   End If

   If S > C Then                                            ' Minutenzaehler uebergelaufen

     S = 0                                                  ' Zhler zurcksetzen
     Toggle T                                               ' Togglebit umschalten

     If T = 0 Then

        Portb.0 = 1                                         ' MAX232 soll Polaritaet A ausgeben

        Portb.3 = 1                                         ' Betriebsspannung MAX232 ein
        Portb.4 = 1

        Waitms 400

        Portb.3 = 0                                         '  Betriebsspannung MAX232 aus
        Portb.4 = 0
        Portb.0 = 0

        Else

        Portb.0 = 0                                         ' MAX232 soll Plaritaet B ausgeben

        Portb.3 = 1
        Portb.4 = 1

        Waitms 400

        Portb.3 = 0
        Portb.4 = 0

     End If

  End If

Idle

Loop




'--- Interrupt- Routine  ----------------------------------


Ontimer0:

    Incr S

Return